import { IScreenInput } from '../interfaces/controls/IInput';
import { IScreen, IScreenData, MoveEventType } from '../interfaces/controls/IScreen';
import { Control } from './Control';
/**
 * Screen can be used to get mouse input
 */
export declare class Screen extends Control<IScreenData> implements IScreen {
    /**
     * How the control will handle move events
     */
    sendMoveEvents: MoveEventType;
    /**
     * The throttle rate for input sent
     */
    moveThrottle: number;
    /**
     * Whether the control sends the mouse down event.
     */
    sendMouseDownEvent: boolean;
    /**
     * Whether the control sends the mouse up event.
     */
    sendMouseUpEvent: boolean;
    /**
     * Sends an input event from a participant to the server for consumption.
     */
    giveInput(input: IScreenInput): Promise<void>;
}
